class CometChatCallsConstants{
  ///SuccessMessages

  ///Errors

  ///Code
  /// These constants are used to represent the error codes that can be returned by the CometChatCalls SDK.
  ///
  /// * `CODE_ERROR` - This error code is returned when an unexpected error occurs.
  /// * `CODE_COMETCHATCALLS_SDK_INIT_ERROR` - This error code is returned when the CometChatCalls SDK fails to initialize.
  /// * `CODE_SESSION_ID_NULL` - This error code is returned when the session ID is null.
  /// * `CODE_USER_AUTH_TOKEN_NULL` - This error code is returned when the user auth token is null.
  static const String codeError = "ERROR";
  static const String codeCometChatCallsSDKInitError = "COMETCHATCALLS_SDK_INIT_ERROR";
  static const String codeSessionIdNull = "SESSION_ID_NULL";
  static const String codeUserAuthTokenNull = "USER_AUTH_TOKEN_NULL";

  ///Calling
  /// The `CALL_STATUS_CANCELLED` constant is used to indicate that the call has been cancelled.
  static const String callStatusCancelled = "cancelled";

  /// The `CALL_STATUS_REJECTED` constant is used to indicate that the call has been rejected.
  static const String callStatusRejected = "rejected";

  /// The circle avatar mode.
  static const String avatarModeCircle = 'circle';

  /// The square avatar mode.
  static const String avatarModeSquare = 'square';

  /// The fullscreen avatar mode.
  static const String avatarModeFullScreen = 'fullscreen';

  /// The spotlight mode.
  static const String modeSpotlight = 'SPOTLIGHT';

  /// The single mode.
  static const String modeSingle = 'SINGLE';

  /// The default mode.
  static const String modeDefault = 'DEFAULT';

  /// The contain aspect ratio.
  static const String aspectRatioContain = 'contain';

  /// The cover aspect ratio.
  static const String aspectRatioCover = 'cover';

  /// The default aspect ratio.
  static const String aspectRatioDefault = 'default';

  /// The top-right position.
  static const String positionTopRight = 'top-right';

  /// The top-left position.
  static const String positionTopLeft = 'top-left';

  /// The bottom-right position.
  static const String positionBottomRight = 'bottom-right';

  /// The bottom-left position.
  static const String positionBottomLeft = 'bottom-left';

}